/* timer.c */
/* $Id: timer.c,v 1.9 1993/09/06 19:33:01 nils Exp $ */

/* Subroutines for timed events */
#include "copyright.h"

#include <stdio.h>
#include <ctype.h>
#include <fcntl.h>
#ifdef XENIX
#include <sys/signal.h>
#else
#include <signal.h>
#endif /* xenix */

#include "db.h"
#include "config.h"
#include "interface.h"
#include "match.h"
#include "externs.h"
static int alarm_triggered=0;
extern char ccom[1024];

static signal_type alarm_handler(i)
     int i;
{
  alarm_triggered=1;
  signal(SIGALRM,alarm_handler);
#ifdef void_signal_type
  return;
#else
  return 0;
#endif
}

void init_timer()
{
  signal(SIGALRM,alarm_handler);
  signal(SIGHUP,alarm_handler);
  alarm(1);
}

void dispatch()
{         
  extern FILE *command_log;
  /* this routine can be used to poll from interface.c */
  if (!alarm_triggered)
    return;
  alarm_triggered=0;
  do_second();
#ifdef RESOCK
    {
     static int ticks=300;     /* every 5 mins, reset the connection. */
     if (!ticks--) {
       ticks = 300;
       resock();
     }
   }
#endif
  /* Free list re ruction */
  {
    static int ticks= -1;
    if (ticks == -1) ticks = fixup_interval;

    if (!ticks--) {
	if (command_log) {
	  fprintf(command_log,"Dbcking...");
	  fflush(command_log);
	}

	ticks=fixup_interval;
	strcpy(ccom,"dbck");
	do_dbck(root);
	if(command_log) {
	  fprintf(command_log,"...Done.\n");
	  fflush(command_log);
	}
      }
  }
  /* Database dump routines */
  {
    static int ticks = -1;
    if (ticks == -1) ticks = dump_interval;

    if (!ticks--) {
	if(command_log) {
	  fprintf(command_log,"Dumping.\n");
	  fflush(command_log);
	}
	ticks=dump_interval;    
	strcpy(ccom,"dump");
	fork_and_dump();
      }
  }
  {
    int i;
    for (i=0; i<((db_top/300)+1); i++) 
      update_bytes();
  }

  strcpy(ccom,"garbage");
  do_incremental(); /* handle incremental garbage collection */
  run_topology();
  /* reset alarm */
  alarm(1);
}
